#include <Servo.h>
#define pump  2
#define valve 4

const int numRows = 4;       // numero di righe
const int numCols = 3;       // numero di colonne
const int numServo = 3;      // numero di servo (usati)
const int debounceTime = 20; // millisecondi necessari allo switch per diventare stabile

Servo servo[numServo]; //i 3 servomotori 
int angolo[numServo];  //angoli relativi ai servomotori
int angolo1[numServo]; //variabili di appoggio

// Definisco i pin connessi alle righe o alle colonne
int rowPins[numRows] = {3, 15, 16, 17}; // Pin di arduino connessi ai pin 1,2,3 e 4 delle righe del keypad
int colPins[numCols] = {18, 19, 5};   // Pin di arduino connessi ai pin 5,6,7 delle colonne del keypad
char c;
char c1;
int num;
String comando = "";
String numero = "";

void setup()
{
  Serial.begin(9600);
  for(int row = 0; row < numRows; row++){
    pinMode(rowPins[row],INPUT);       // Imposta i p1n delle righe come input
    digitalWrite(rowPins[row],HIGH);   // Imposta le righe a HIGH (inattiva) - abilita le resistenze di pull-ups
  }
  for(int column = 0; column < numCols; column++){
    pinMode(colPins[column],OUTPUT);     
    digitalWrite(colPins[column],HIGH);  
  }
  pinMode(pump, OUTPUT);
  pinMode(valve, OUTPUT);

  digitalWrite(pump, HIGH);
  digitalWrite(valve, HIGH); //HIGH SUCCHIO  LOW RILASCIO
  
  servo[0].attach(11);
  servo[1].attach(10);
  servo[2].attach(9);

  //angoli di partenza
  angolo[0] = 110; 
  angolo[1] = 120;
  angolo[2] = 75;
  
  servo[0].write(angolo[0]);
  servo[1].write(angolo[1]);
  servo[2].write(angolo[2]);
}

void loop()
{
  tastierino(angolo);

  if (Serial.available()) {
    c = Serial.read();
    if(c == ' ' && comando != "vai"){
      Serial.print(comando);
      Serial.print(" ");
      do{
        if(Serial.available()){     
          c1 = Serial.read();
            if((c1 != '\n') &&  (c1 != '\r') && (c1 != ' '))
              numero += c1;
            else{
              Serial.println(numero);
              if(comando == "base"){
                num = numero.toInt();
                servoMovementup(20, num, angolo[1], angolo[2], 100, 90, 90);
              }else if(comando == "spalla"){
                num = numero.toInt();
                servoMovementup(20, angolo[0], num, angolo[2], 100, 90, 90);
              }else if(comando == "gomito"){
                num = numero.toInt();
                servoMovementup(20, angolo[0], angolo[1], num, 100, 90, 90);
              }
              numero = ""; 
            }
        }
      }while (c1 != '\n' && c1 != '\r'); 
      comando = "";
      c1 = ' ';
    }else if (c == '\n' || c == '\r'){ //se scrivi "vai"
       angolo1[0] = angolo[0];
       angolo1[1] = angolo[1];
       angolo1[2] = angolo[2];
       Serial.print(comando);
       Serial.print(" ");
       servoMovementup(20, 110, 120, 75, 100, 90, 90); //posizione base
       servoMovementdown(20, angolo1[0], angolo1[1], angolo1[2], 100, 90, 90); //ultimi angoli segnati
       Serial.print(angolo[0]); 
       Serial.print(" ");
       Serial.print(angolo[1]);
       Serial.print(" ");
       Serial.println(angolo[2]);
       comando = "";
    }else{
      comando += c;
    }
  }
}

void tastierino(int angolo[])
{ 
  int premuto = 0;                               
  for(int column = 0; column < numCols && premuto == 0; column++)
  {
    digitalWrite(colPins[column],LOW);         // Attiva la colonna corrente per la lettura.
    for(int row = 0; row < numRows && premuto == 0; row++)     // Scorro tutte le righe cercando un tasto premuto
    {
      if(digitalRead(rowPins[row]) == LOW){     /* E' premuto il tasto*/
        premuto = 1;
        delay(debounceTime);                     // attendo che il segnale si stabilizzi 
        if(row == 3){ //Devo stampare i valori
          while(digitalRead(rowPins[row]) == LOW); //aspetto che il tasto sia rilasciato
          if(column == 0)
            Serial.print("Base: ");
          else if(column == 1)
            Serial.print("Spalla: ");
          else if(column == 2)
            Serial.print("Gomito: ");
          Serial.println(String(angolo[column]));  //Stampo l'angolo relativo al servomotore che ho scelto in base alla colonna
        }else{
          while(digitalRead(rowPins[row]) == LOW); //aspetto che il tasto sia rilasciato
          movimento(angolo, row, column);
        }
      }
    }
    digitalWrite(colPins[column],HIGH);     // Rendo inattiva la colonna.
  }
}

void movimento(int angolo[], int riga, int colonna)
{
  if(colonna == 0){ //aumenti l'angolo
      angolo[riga]++;
      if (angolo[0] > 180) //protezioni per evitare di danneggiare il robot, angoli limite 
        angolo[0] = 180;
      if (angolo[1] > 165) 
        angolo[1] = 165;
      if (angolo[2] > 180) 
        angolo[2] = 180;
      servo[riga].write(angolo[riga]);
  }else if(colonna == 2){ //diminuisci l'angolo
      angolo[riga]--;
      if (angolo[0] < 0) //protezioni per evitare di danneggiare il robot, angoli limite 
        angolo[0] = 0;
      if (angolo[1] < 15) 
        angolo[1] = 15;
      if (angolo[2] < 0) angolo[2] = 0;
      servo[riga].write(angolo[riga]);
  }
  if(riga == 0)
    Serial.print("Base ");
  else if(riga == 1)
    Serial.print("Spalla ");
  else if(riga == 2)
    Serial.print("Gomito ");
    
  Serial.println(angolo[riga]);
}

//Funzioni per il movimento del "vai":

void servoMovementdown(int stepDelay, int vBase, int vShoulder, int vElbow, int vWrist_ver, int vWrist_rot, int vgripper) {

  stepDelay = 20;
  int exit = 1;

  //Until the all motors are in the desired position
  while (exit)
  {
    //For each servo motor if next degree is not the same of the previuos than do the movement
    while (vBase != angolo[0])
    {
      servo[0].write(angolo[0]);
      //One step ahead
      if (vBase > angolo[0]) {
        angolo[0]++;
      }
      //One step beyond
      if (vBase < angolo[0]) {
        angolo[0]--;
      }
      delay(stepDelay);
    }

    while (vShoulder != angolo[1])
    {
      servo[1].write(angolo[1]);
      //One step ahead
      if (vShoulder > angolo[1]) {
        angolo[1]++;
      }
      //One step beyond
      if (vShoulder < angolo[1]) {
        angolo[1]--;
      }
      delay(stepDelay);
    }

    while (vElbow != angolo[2])
    {
      servo[2].write(angolo[2]);
      //One step ahead
      if (vElbow > angolo[2]) {
        angolo[2]++;
      }
      //One step beyond
      if (vElbow < angolo[2]) {
        angolo[2]--;
      }
      delay(stepDelay);
    }
    //delay between each movement
    

    //It checks if all the servo motors are in the desired position
    if ((vBase == angolo[0]) && (vShoulder == angolo[1])
        && (vElbow == angolo[2])) {
      exit = 0;
    } else {
      exit = 1;
    }
  }
}

void servoMovementup(int stepDelay, int vBase, int vShoulder, int vElbow, int vWrist_ver, int vWrist_rot, int vgripper) {

  stepDelay = 20;
  int exit = 1;

  //Until the all motors are in the desired position
  while (exit)
  {
    //For each servo motor if next degree is not the same of the previuos than do the movement
    while (vElbow != angolo[2])
    {
      servo[2].write(angolo[2]);
      //One step ahead
      if (vElbow > angolo[2]) {
        angolo[2]++;
      }
      //One step beyond
      if (vElbow < angolo[2]) {
        angolo[2]--;
      }
      delay(stepDelay);
    }

     while (vShoulder != angolo[1])
    {
      servo[1].write(angolo[1]);
      //One step ahead
      if (vShoulder > angolo[1]) {
        angolo[1]++;
      }
      //One step beyond
      if (vShoulder < angolo[1]) {
        angolo[1]--;
      }
      delay(stepDelay);
    }
    
    while (vBase != angolo[0])
    {
      servo[0].write(angolo[0]);
      //One step ahead
      if (vBase > angolo[0]) {
        angolo[0]++;
      }
      //One step beyond
      if (vBase < angolo[0]) {
        angolo[0]--;
      }
      delay(stepDelay);
    }
    
    //It checks if all the servo motors are in the desired position
    if ((vBase == angolo[0]) && (vShoulder == angolo[1])
        && (vElbow == angolo[2])) {
      exit = 0;
    } else {
      exit = 1;
    }
  }
}
